module Airy
	
	real(kind=8),parameter,private::c1=0.355028053887817, c2=0.258819403792807
	
	
	public AiryAi,AiryBi
	private f,g


	contains
		
		
		function AiryAi(z,tol)

		implicit none

			complex (kind=8)::AiryAi
			complex (kind=8)::z
			real(kind=8),intent(in),optional::tol
			real eps
		
			if (.not.present(tol)) then
				eps=1.0d-8
			else
				eps=tol
			end if

			AiryAi=c1*f(z,eps)-c2*g(z,eps)


		end function AiryAi

		function AiryBi(z,tol)

		implicit none
		
			complex (kind=8)::AiryBi
			complex (kind=8)::z
			real(kind=8),intent(in),optional::tol
			real eps
		
			if (.not.present(tol)) then
				eps=1.0d-8
			else
				eps=tol
			end if

			AiryBi=(c1*f(z,eps)+c2*g(z,eps))*sqrt(3.0)


		end function AiryBi

		function f(z,eps)
		
		implicit none	
			
			complex (kind=8)::f
			complex(kind=8) z,f1,fsum
			real eps,temp
			integer k

			f1=(1.0,0.0)
			fsum=(1.0,0.0)
			k=1

			do while (abs(f1)>eps)
			
				f1=f1*(z**3.0)/(3.0*k-1)/(3*k)
				fsum=fsum+f1
				k=k+1
				
			end do

			f=fsum

		end function f

		function g(z,eps)

		implicit none
			
			complex (kind=8)::g
			complex(kind=8) z,g1,gsum
			real eps,temp
			integer k

			g1=z
			gsum=z
			k=1

			do while (abs(g1)>eps)
			
				g1=g1*(z**3)/(3*k+1)/(3*k)
				gsum=gsum+g1
				k=k+1
				
			end do

			g=gsum

		end function g


end module Airy




	