module NDerive

contains

	function D(f,x,eps,method,maxIter)

	implicit none

		real(kind=8)::D
		real(kind=8),intent(in)::x
		real(kind=8),intent(in),optional::eps
		integer(kind=4),intent(in),optional::maxIter
		optional::method

	interface

	function f(x)

	implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

function method(x,h,f)

implicit none

	real(kind=8)::method
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

end interface

end function method

end interface

real(kind=8)::tol,step
real(kind=8)::derPrev,derCurr,derNext
integer(kind=4)::max,i
logical::ok

if (present(eps)) then
tol=eps
else
tol=1.0d-7
end if
!step=1.0d-1*x

if (present(method)) then
derPrev=method(x,step,f)
step=1.0e-1_8*step
derCurr=method(x,step,f)
i=0
do
	step=1.0e-1_8*step
	derNext=method(x,step,f)
	ok=(abs(derNext-derCurr)>=abs(derCurr-derPrev)).OR.(abs(derCurr-derPrev)<tol)
	if(i>max) stop 'Error!!! Too Many Steps in D Calculation'
	i=i+1
	derPrev=derCurr
	derCurr=derNext
	if(ok) exit

end do
else
derPrev=derDet(x,step)
step=1.0e-1_8*step
derCurr=derDet(x,step)
i=0
do
	step=1.0e-1_8*step
	derNext=derDet(x,step)
	ok=(abs(derNext-derCurr)>=abs(derCurr-derPrev)).OR.(abs(derCurr-derPrev)<tol)
	f(i>max) stop 'Error!!! Too Many Steps in D Calculation'
	i=i+1
	derPrev=derCurr
	derCurr=derNext
	if(ok) exit

end do
end if

D=derCurr

contains

function derDet(x,h)

implicit none

	real(kind=8)::derDet
	real(kind=8),intent(in)::x,h

	derDet=(f(x+h)-f(x))/h

end function derDet

end function D

function der3ptBackward(x,h,f)

implicit none

	real(kind=8)::der3ptBackward
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der3ptBackward=

end function der3ptBackward


function der3ptForward(x,h,f)

implicit none

	real(kind=8)::der3ptForward
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der3ptForward=

end function der3ptForward


function der3ptCenter(x,h,f)

implicit none

	real(kind=8)::der3ptCenter
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der3ptCenter=

end function der3ptCenter


function der5ptBackward(x,h,f)

implicit none

	real(kind=8)::der5ptBackward
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der5ptBackward=

end function der5ptBackward


function der5ptForward(x,h,f)

implicit none

	real(kind=8)::der5ptForward
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der5ptForward=

end function der5ptForward


function der5ptCenter(x,h,f)

implicit none

	real(kind=8)::der5ptCenter
	real(kind=8),intent(in)::x,h

interface

function f(x)

implicit none

	real(kind=8)::f
	real(kind=8),intent(in)::x

end function f

!der5ptCenter=

end function der5ptCenter

end module NDerive