program Task1

	use NDSolve
	use odeFun

	implicit none

	real(kind=8)::a=0.0d0,b=2.0d0,alpha=5.0d-1
	real(kind=8)::tol=1.0d-5,hMax=0.05,hMin=0.01

	real(kind=8)::t,y,step=0.1d0

	call getData()

	t=a;y=alpha
	call output(t,y,0)
	call output(t,y,1)

	do while(t<b)
		call odeSolve(ode,t,t+step,y,y,tol,hMax,hMin)
		t=t+step
		call output(t,y,1)
	end do
	call output(t,y,2)

	contains

		subroutine getData()

		print '(1x,a,$)','Inut initial condition y(0): '
		read *, alpha

		end subroutine getData

		subroutine output(t,y,flag)

			implicit none
	
			real(kind=8),intent(in)::t,y
			integer(kind=4),intent(in)::flag
			real(kind=8)::analSol

			if(flag == 0) then
				print 3, 'Pos', 'Res', 'Err'
				open(111, file = 'Result.dat')
				write(111, 3) 'Pos', 'Res', 'Err'
				3 format(6x, a5, 9x, a5, 9x, a5)
			else if (flag == 1) then
				analSol = solAnalyt(t)
				print 5, t, y, abs(y - analSol)
				write(111, 5) t, y, abs(y - analSol)
				5 format(1x, f12.6, 2x, f12.6, 2x, f12.6, 2x, f12.6)
			else
				close(111)
			end if

		end subroutine output

	function solAnalyt(t)

		implicit none

		real(kind=8) :: solAnalyt
		real(kind=8), intent(in) :: t
		
		solAnalyt = (1.0d0 + t)**2 + (alpha - 1.0d0)*dexp(t)

	end function solAnalyt

end program Task1




