      module Task1mod

	    integer(kind=4), allocatable :: a(:) 
		integer(kind=4) ::num

		private constructArray, destroyArray

	  contains
		subroutine  constructArray(n)  
		  implicit none

		  integer(kind=4), intent(in) :: n
		  integer(kind=4) ::error

		  allocate(a(1:n), stat=error)
		  if (error /= 0) stop 'Allocation memory error'

		end subroutine constructArray

		subroutine destroyArray()
		  implicit none

		  integer(kind=4)::error

		  deallocate(a, stat=error)
		  if (error /= 0) stop 'Deallocations memory error'
		end subroutine destroyArray

		subroutine readArray(fileName)
		  implicit none

		  character(len=*), intent(in) :: fileName

		  integer(kind=4) ::i, error
		  character(len=80) ::msg

		  open(33, file=trim(fileName), form='unformatted', status='old', &
		      action='read', iostat=error, iomsg=msg)
		  if(error /= 0) then
		    print *, 'IOError while opening file ' // trim(fileName) 
			print *, trim(msg) 
			stop 'IOError!'
		  end if
		  read(33) num
		  call constructArray(num) 
		  do i = 1, num
		    read(33) a(i) 
		  end do 
		  close(33, status='keep')
		end subroutine readArray

		subroutine makeArray(fileName) 
		  implicit none 
		  character(len=*), intent(in) ::fileName

		  character(len=1):: ans
		  integer(kind=4):: i, error
		  character(len=80)::msg
		  real(kind=4) :: x

		  integer(kind = 4), parameter :: LEFT =-10, RIGHT = 10

		  do 
		    print '(a, $)', 'Array size: '
			read *, num
			if (num > 0) exit
			print *, 'Size of array must be positive'
		  end do 

		  call constructArray(num) 
		  print *, 'Type y or Y to manual input or any other to automatic'
		  print '(3x, a, $)', '->'
		  read *, ans
		  if((ans == 'y').OR.(ans == 'Y')) then
		    print *, 'Manual'
			print '("Type ", i3, "array values")', num
			do i = 1, num 
			  print '(5x, "a[", i2, "]: ", $)', i
			  read *, a(i) 
			end do 
		  else 
		    print *, 'Authomatic'
			call random_seed()
			do i = 1, num 
			  call random_number(x) 
			  a(i) = nint(LEFT + (RIGHT - LEFT)*x)
			end do
		  end if

          open(22, file=trim(fileName), form='unformatted', status='new', &
		      action='write', iostat=error, iomsg=msg)
		  if(error /= 0) then
		    print *, 'IOError while opening file ' // trim(fileName) 
			print *, trim(msg) 
			stop 'IOError!'
		  end if

		  write(22) num
		  do i = 1, num 
		    write(22) a(i) 
		  end do 
		  close(22, status='keep') 
		end subroutine makeArray

		subroutine processArray(fileName) 

		  implicit none

		  character(len=*), intent(in) :: fileName 

		  if (isFileExists(trim(fileName))) then
		    call readArray(fileName) 
			print *, 'Read array from file'
			call readArray(fileName) 
		  else
		    call makeArray(fileName) 
			print *, 'Create array and write to the file'
		  end if 

		  call printArray()

		  print '(3x, a, i3, a, a)', 'There are ', znakChanges(), ' sign ', &
		       'changes in the array'
		  call destroyArray()

		 contains
		   subroutine printArray()

		     integer(k
			 ind = 4) ::i 

			 print '(3x, a)', 'Array'
			 do i = 1, num
			   print '(1x, i3, $)', a(i) 
			 end do
			 print *
		   end subroutine printArray

		end subroutine processArray

		function znakChanges()

		  implicit none

		  integer(kind=4) ::znakChanges
		  integer(kind=4) ::i, pred, curr, res

		  res = 0 
		  pred = znak(a(1))
		  do i = 2, num 
		    curr = znak(a(i))
			if (pred /= curr) then 
			  res = res + 1
			  pred = curr
			end if
		  end do 
		  znakChanges = res
		end function znakChanges

		function znak(a) 
		  implicit none

		  integer (kind = 4) :: znak
		  integer(kind = 4), intent(in) :: a 

		  if ( a >= 0 ) then
		    znak = 1
		  else 
		    znak = -1
		end if 

	  end function znak 

	  function isFileExists(fileName)

	    implicit none

		character(len = * ) , intent(in) ::fileName
		logical(kind = 4) ::isFileExists

		inquire(file=fileName, exist=isFileExists)
	  end function isFileExists
    end module Task1mod




