      module Task3mod

	    integer(kind=4), private, parameter :: STR_WIDTH = 60

		public getFileName, isFileExists, calcNumLetters, processFile
		private isCapitalLetter, isSmallLetter

	  contains
	    subroutine getFileName(fileName)

		  implicit none

		  character(len=*), intent(out) ::fileName
		  write(*, '(a, i3, a)', advance='no') &
		        'Type working file name of maximum ', &
				len(fileName), ' symbols: '
		  read '(a)', fileName
		end subroutine getFileName

		function isFileExists(fileName)
		  implicit none

		  logical(kind=4) :: isFileExists

		  character(len=*), intent(in) :: fileName

		  inquire(file=trim(fileName), exist=isFileExists)
		end function isFileExists

		function isLatinLetter(symbol)
		  implicit none

		  logical(kind = 4) :: isLatinLetter
		  character(len = 1) :: symbol

		  integer(kind = 4) :: code
		  integer(kind = 4), parameter :: code_big_A = 65, code_big_Z = 90, code_small_a = 97, code_small_Z = 122

		  code = iachar(symbol) 

		  isLatinLetter = .FALSE.
		  if (((code >= code_big_A).AND.(code <= code_big_Z)).OR.((code >= code_small_a).AND.(code <= code_small_z))) &
		        isLatinLetter = .TRUE.
		end function isLatinLetter

		function isNotNullNumber(symbol)
		  implicit none

		  logical(kind = 4) :: isNotNullNumber
		  character(len = 1) :: symbol

		  integer(kind = 4) :: code
		  integer(kind = 4), parameter :: code_1 = 49, code_9 = 57

		  code = iachar(symbol) 

		  isNotNullNumber = .FALSE.
		  if ((code >= code_1).AND.(code <= code_9)) isNotNullNumber = .TRUE.
		end function isNotNullNumber

		function checkCondition(fileName)

		  implicit none

		  character(len=*), intent(in) ::filename
		  logical(kind=4):: checkCondition;
		  character(len=STR_WIDTH) ::str
		  integer(kind = 4) ::status, i, firstNumber


		  open(11, file=trim(fileName), status='old', action='read', &
		      iostat = status, iomsg = str) 
		  if(status /= 0) then
		    print *, 'File ' // trim(fileName) //' opening error'
			print *, trim(str) 
			stop 'Check Error and restart the program'
		  end if

		  do 
		    read(11, '(a)', iostat=status) str
			if (status /= 0) exit
			firstNumber = 0
			checkCondition = .TRUE.
			do i = 1, len_trim(str)
			  if (i == 1) then
			    if (isNotNullNumber(str(i:i))) then 
			      firstNumber = iachar(str(i:i)) - 48
				  ! ,       + 1 (  )
				  if (firstNumber /= (len_trim(str) - 1)) checkCondition = .FALSE.
			    else 
			      checkCondition = .FALSE.
			    endif
			  endif
			  if ((i > 1).AND.(.NOT.(isLatinLetter(str(i:i))))) checkCondition = .FALSE.
			end do
		  end do

			close(11, status='keep')
		  end function checkCondition


	  end module Task3mod