      module Task5mod
	    
		integer(kind=4), allocatable, private :: m(:,:)
		integer(kind=4), save, private :: row, col

	  contains 
	    !==================================
		function isFileExists(fileName) 

		  implicit none

		  character(len=*), intent(in)::fileName
		  logical(kind=4):: isFileExists

		  inquire(file=trim(fileName), exist=isFileExists)
		end function isFileExists
		!==================================
		subroutine getArray(fileName) 

		  implicit none

		  character(len=*), intent(in) :: fileName

		  integer(kind=4) :: i,j,error
		  character(len=80) :: msg

		  if (isFileExists(trim(fileName))) then 
		    print *, 'Read array and write to the file: ' // trim(fileName)
			call readArray()
		  else
			call makeArray()
			call writeArray()
		  end if

		contains
		  subroutine readArray()
		    open(33, file=trim(fileName), form='unformatted', &
			    status='old', action='read', iostat=error, iomsg=msg)
			if (error /= 0) then
			  print *, 'IoError while openning file' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			read(33) row, col
			call constructArray()
			read(33) m
			close(33, status='keep') 
		  end subroutine readArray

		  subroutine makeArray()

		    character(len=1) ::ans
			integer(kind=4), parameter::LEFT = -50, RIGHT = 50
			real(kind=4)::x

			do
			  print'(a,$)', 'Number of rows:'
			  read *, row
			  if (row > 0) exit
			  print *, 'Number of rows must be positive'
			end do

			do 
			  print'(a,$)', 'Number of cols:'
			  read *, col
			  if (col > 0) exit
			  print *, 'Number of cols must be positive'
			end do

			call constructArray()

			print *, 'Type y or Y to manual input or any other to authomatic'
			print '(3x, a, $)', '-> '
			read *, ans

			if ((ans=='y').OR.(ans=='Y')) then
			  print *, 'Manual'
			  print '("Type ", i3, " array rows")', row
			  print '("Type ", i3, " elements end press <Enter> ")', col
			  do i = 1, ROW 
			    print '(5x, "row ", i2, ": ", $)', i
				read *, (m(i,j), j = 1, COL)
			  end do
			else 
			  print *, 'Authomatic'
			  call random_seed()
			  do i = 1, row
			    do j = 1, col
				  call random_number(x)
				  m(i,j) = nint(LEFT + (RIGHT-LEFT)*x) 
				end do
			  end do 
			end if

		  end subroutine makeArray

		  subroutine writeArray()
		    open(22, file = trim(fileName), form='unformatted', &
			     status='new', action='write', &
				 iostat=error, iomsg=msg)
			if (error /= 0) then
              print *, 'IoError while openning file ' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			write(22) row, col
			write(22) m
			close(22, status='keep')
		  end subroutine writeArray
		end subroutine getArray
		!===============================
		subroutine constructArray()
		 implicit none

		 integer(kind=4) :: error

		 allocate(m(1:row, 1:col), stat=error) 
		 if (error /= 0) stop 'Allocation memory error'

		end subroutine constructArray
		!===============================
		subroutine destroyArray()
		  implicit none

		  integer(kind=4) ::error

		  deallocate(m, stat=error)
		  if (error /= 0) stop 'Deallocation memory error'

		end subroutine destroyArray
		!===============================
		subroutine printArray()
		  implicit none

		  integer(kind=4) :: i, j

		  do i= 1, ROW
		    do j= 1, COL
			  print '(i4, $)', m(i,j)
			end do
			print *
		  end do
		end subroutine printArray
		!===========================
		subroutine findNullRowsAndCoumns()

		  implicit none

		  logical(kind=4) ::isNullExists
		  integer(kind=4) :: i, j, sum

		  isNullExists = .FALSE.
		  do i = 1, ROW
		    ! Let sum element in row i
			sum = 0
			do j = 1, COL
			  sum = sum + m(i, j)
			end do 
			if (sum == 0) then
			  isNullExists = .TRUE.
			  print *, "Row index with null elements: ", i
			end if
		  end do

		  do i = 1, COL
		    ! Let sum element in column i
			sum = 0
			do j = 1, ROW
			  sum = sum + m(j, i)
			end do 
			if (sum == 0) then
			  isNullExists = .TRUE.
			  print *, "Column index with null elements: ", i
			end if
		  end do

		  if (.NOT. isNullExists) print *, "There is no null rows or columns in matrix"
		end subroutine findNullRowsAndCoumns
	  end module Task5mod